/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */


/*
 * example.cpp
 *
 *  Created on: 2010/11/18
 *      Author: HARK Development Team
 */

/*
 * 次元保証ライブラリ使用サンプル
 */

#include <iostream>
#include "../dimpro.hpp"

using namespace std;
using namespace NSDimensionPromise;

int main()
{
  Length len1(20); // 20 meter
  Length len2(3); // 3 meter
  Area s;
  Length l;
  Angle ang;

  s = len1 * len2; // OK
  // l = len1 * len2; // ERROR
  cout << "area s = " <<
      s.ToSquareMeter() << " m^2 = " <<
      s.ToSquareMillimeter() << " mm^2" << endl;

  // s = len1 + len2; // ERROR
  l = len1 + len2;
  cout << "length l = " <<
      l.ToMeter() << " m = " <<
      l.ToMillimeter() << " mm" << endl;

  // a = len1; // ERROR
  ang = len1 / len2; // OK
  cout << "angle ang = " <<
      ang.ToDegree() << " deg = " <<
      ang.ToRadian() << " rad" << endl;
  return 0;
}
